'SDCard YModem tranfer and utilities
'(C) 2008 Raymond Allen
' Free for non-commercial (except Prop-OLED Contest!) usage as long as this file and notice are not altered
' Not extensively tested!  Use at own risk!
'

' modified by cheezus to use kye's sd, added run program dec 2018,
' more tweaks feb 2019, added baud support


CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency 
'  _xinfreq = 6_250_000           'to achieve 100 Mhz clock frequency 
  SD_Basepin=24  'basepin for SD card driver

  DEFAULTBAUDRATE = 115200    'baud rate for serial communications , release should set 9600 for compatibility
  RXPIN=31        'Prop pins used for comms
  TXPIN=30
                                              
  'XMODEM chars from ymodem.txt
  SOH=$01
  STX=$02
  EOT=$04
  ACK=$06
  NAK=$15
  CAN=$18
  Cee=$43  'liberties here
  Zee=$1A  'or SUB  (DOS EOF?)

OBJ  'Objects Section

  ser : "FullDuplexSerialExtended"  'for serial comms with big buffer
  sdfat : "SD-MMC_FATEngine"  'Kye's SD 
  num : "numbers"  'to format numbers 
{
DAT
        stack long 0[500]         
        fbuf  byte 0[30]
        sbuf  byte 0[30]
        pdata byte 0[1028]
        cog   byte 0
        alone byte 0
        }
var
   byte cog, alone
   long stack[500]
   byte fbuf[30]
   byte sbuf[30]
   byte pdata[1028] 'packet data
    

    
PUB Strap
  Start("y")
  repeat
   
PUB Start(standalone)
  alone := standalone
  if TXPIN
    if alone == "n" or alone == "N"
      cog := cognew(Run,@stack)  +1
    else
      Run
      
PUB Stop
  ser.str(string(27,13,10,"[2J Quitted",7))
  waitcnt(cnt+clkfreq)      
  ser.stop
       
  if alone == "y" or alone == "Y"
    sdfat.unmountPartition
    sdfat.FATEngineStop
  else         
    if cog
      cogstop(cog~ - 1)   
    
PRI Run| i

  num.init                                            'start numbers
  ser.start(RXPIN,TXPIN,0,DEFAULTBAUDRATE)                   'open comm port

  'Establish serial link (wait for client to hit spacebar)
  i:=0
  repeat until i==32
    waitcnt(cnt+clkfreq)
    ser.str(string(27,13,10,"[2J Hit spacebar to continue"))
    repeat 
      i:=ser.rxcheck
    while i>0 and i<>32   
 
  if alone == "y" or alone == "Y"
    sdfat.FATEngineStart(SD_Basepin, SD_Basepin+1, SD_Basepin+2, SD_Basepin+3, -1, -1, -1, -1, -1)
    i :=  \sdfat.mountPartition(0)
    
  repeat
    Debug(i)
    i := \Menu
    
PUB Menu  | i

  repeat                        'Show welcome logo 
    ser.str(string(27,13,10, "[2J   YModem file transfer utility"))
    ser.str(string(   13,10,    " Main Menu - Cheezus Edition v0_1_0",10,13))
    ser.str(string(             "=======================================", 13,10,13))
    ser.str(string(             "D = Directory of SD card", 13,10))
    ser.str(string(             "S = Send files to SD card", 13,10))
    ser.str(string(             "R = Receive a file from SD card", 13,10))
    ser.str(string(             "X = Erase file on SD card", 13,10))
    ser.str(string(             "U = Run file on SD card", 13,10))
    ser.str(string(             "B = Change Baud", 13,10))            
    ser.str(string(             "Q = Quit", 13,10))   
    i:=0
    repeat
      i:=ser.rxcheck
    until i>0
    case i
      "D","d": 'directory
        dir
      "Q","q": 'quit
        Stop                   
      "R","r":  'receive file
        Receive
      "S","s":  'send file
        Send
      "X","x":  'erase file
        Erase
      "U","u":  'run file
        Chain
      "b","B":  'change baud 
         NewBaud
         return
      OTHER : return     
    ser.rxflush    
    Waitkey(32,string(13,10,"Hit spacebar to continue",13,10))

PUB NewBaud  | ba, key
  ser.str(string(27,13,10, "[2J  Select new baud: ", 13,10))
  ser.str(string(               "=====================", 13,10))
  ser.str(string(               "1        =       9600", 13,10))
  ser.str(string(               "2        =      19200", 13,10))
  ser.str(string(               "3        =      57600", 13,10))
  ser.str(string(               "4        =     115200", 13,10))
  
  key:=0
  repeat until key== "1" or key== "2" or key== "3" or key== "4" or key== 27
    key:=GetKey

  case key
    "1" : ba := 9600      
    "2" : ba := 19200
    "3" : ba := 57600
    "4" : ba := 115200   
    other:
      AbortMsg
      return 'abort

  ser.str(string(13,10,"Setting new baud  "))
  
  case ba
    9600   :  ser.str(string("= 9600", 13,10))
    19200  :  ser.str(string("= 19200", 13,10))
    57600  :  ser.str(string("= 57600", 13,10))
    115200 :  ser.str(string("= 115200", 13,10))

  ser.str(string(13,10,"Press spacebar to continue or ESC to cancel"))

  key := 0
  repeat until key== 32 or key== 27 
    key:=GetKey
  if key == 27
    AbortMsg
    return 'abort
    
  'waitcnt(cnt+(clkfreq))
  ser.start(RXPIN,TXPIN,0,ba)                   'open comm port


  key:=0
  repeat until key==32
    waitcnt(cnt+clkfreq)
    ser.str(string(27,13,10,"[2J Hit spacebar to continue"))
    repeat 
      key:=ser.rxcheck
    while key>0 and key<>32      
      
PRI AbortMsg
        ser.str(string(13,10,"Aborted by keystroke"))
        waitcnt(cnt+clkfreq)  

PUB str(stringptr)
    ser.str(stringptr)
    
PUB dec(value)
    ser.dec(value)
    
PUB hex(value, digits)
    ser.hex(value, digits)
    
PUB bin(value, digits)
    ser.bin(value, digits)

PUB rxflush
    ser.rxflush
PUB rxcheck
    result := ser.rxcheck
    
PUB Chain | i
  ser.str(string(27,"[2JRun a file from SD card."))
  ifnot GetName        ' Get Filename
    return                        
  sdfat.bootPartition(@fbuf)
    Debug(i)
  
PUB Program

PUB dir|lines,key,total,size,b
  lines:=0   
  ser.str(string(27,"[2J    Directory of SD Card: ", 13,10))
  ser.str(string(       "=============================", 13,10))
  ser.str(string(       "Filename        Size in Bytes", 13,10))
  ser.str(string(       "------------    -------------", 13,10))

  repeat while b := sdfat.listEntries("N")  
    repeat 12-strsize(b)                                                                         
     ser.tx(" ")
    ser.str(b)
    ser.str(string("   "))
    size:=sdfat.listSize
    total+=size
    ser.str(num.tostr(size,num#DSDEC14))
    ser.tx(13)
    ser.tx(10)
    if ++lines>20
      Waitkey(32,string("Hit spacebar to continue",13,10))
      lines:=0

  'Show total bytes  
  ser.str(string(13,10,10,"Total: "))
  ser.str(num.tostr(total,num#DSDEC14))   
  ser.str(string(" bytes"))

PUB erase|i
  ser.str(string(27,"[2JErase a file from SD card."))
  ifnot GetName        ' Get Filename
    return
  ser.str(string(13,10,"Are you sure? (Y/N)"))
  i:=ser.rx
  if i<>"Y" and i<>"y"
    AbortMsg
    return
                               
  sdfat.deleteEntry(@fbuf)
      
  if i<0
    ser.str(string(13,10,"Erase Failed."))
  else
    ser.str(string(13,10,"Erase Complete."))

    

PUB send|key,i,packet,crc,j,k,timer,bytes,done, overwrite
  'get file from computer and save to SD
  'Ymodem protocol: http://timeline.textfiles.com/1988/10/14/1/FILES/ymodem.txt


  ser.str(string(27, "[2JSend file to SD Card"))
  ser.str(string(13,10,"Overwrite if exists? y/n"))
  key:=0
  repeat until key== "y" or key== "Y" or key== "n" or key== "N" or key== 27
    key:=GetKey
  if key == 27
    AbortMsg
    return 'abort
  if key == "y" or key == "Y"
    overwrite := true
  else
    overwrite := false
  ser.str(string(13,10,"Send file via ymodem now..."))

  repeat  'batch reception loop
    packet:=0                   'wait for first packet
    repeat until packet==1      'repeat until key==SOH
      key:=0
        waitcnt(cnt+clkfreq*10)
        ser.tx(Cee)
        'waitcnt(cnt+clkfreq*1)
        timer:=cnt
        repeat until i==SOH
          i:=ser.rxcheck
          if i>0
            key:=i
          if (cnt-timer)>clkfreq*5
            ser.tx(EOT)
            ser.str(string(13,10,"No response from host... Aborting."))
            return
      if (ser.rx==0)            'analyze first packet
        if (ser.rx==$FF)
          crc:=0
          j:=0
          i:=-1
          done:=0
          repeat until i==0     'filename
            i:=ser.rx
            if i==0 and j==0
              done:=1           'End of session
            fbuf[j++]:=i
            crc:=UpdateCRC(i,crc)            
          i:=-1
          k:=j
          j:=0
          repeat until i==0 or i==32
            i:=ser.rx
            if i<>32
              sbuf[j++]:=i
            else
              sbuf[j++]:=0
            crc:=UpdateCRC(i,crc)
          k+=j
          bytes:=num.fromstr(@sbuf,num#dec)          
          repeat j from k+1 to 128
            i:=ser.rx
            crc:=UpdateCRC(i,crc)
        else
          ser.tx(NAK)
      else
        ser.tx(NAK) 
      i:=ser.rx
      j:=ser.rx
      if i<>(crc>>8) or j<>(crc&$FF)
        ser.tx(NAK) 
      else
        packet:=1

    if done== 0    
      if overwrite  
        \sdfat.deleteEntry(@fbuf)
      sdfat.newFile(@fbuf)
      sdfat.openFile(@fbuf,"W")

    ser.tx(ACK)
                     'open output file
    if done==1
      waitcnt(cnt+clkfreq)
      ser.str(string("Batch file reception complete."))
      return 

    ser.tx(Cee)                 'receive packets

    k:=0
    repeat until k==EOT
      k:=ser.rx
      if k==SOH                 '128 byte packets
        packet:=ser.rx
        i:=ser.rx
        if (255-i)<>packet
          repeat
        else
          'text.str(string("Good packet header"))
        crc:=0
        repeat j from 0 to 127
          i:=ser.rx
          crc:=UpdateCRC(i,crc)
          pdata[j]:=i
        i:=ser.rx
        j:=ser.rx
        if i<>(crc>>8) or j<>(crc&$FF)
          ser.tx(NAK)
        else                                            'write data          
          if bytes>128
            sdfat.writeData(@pdata,128)
            bytes-=128
          else
            sdfat.writeData(@pdata,bytes)
            bytes:=0
          ser.tx(ACK)                                   'get more
      else
        if k==STX               '1024 byte packets
          repeat j from 0 to 1027
            pdata[j]:=ser.rx           
          packet:=pdata[0]
          i:=pdata[1]
          if (255-i)<>packet
            repeat
          crc:=0
          repeat j from 2 to 1025
            i:=pdata[j]
            crc:=UpdateCRC(i,crc)
          i:=pdata[1026]
          j:=pdata[1027]
          if i<>(crc>>8) or j<>(crc&$FF)
            ser.tx(NAK)
          else                                          'write data
            if bytes>1024
              sdfat.writeData(@pdata+2,1024)
              bytes-=1024
            else
              sdfat.writeData(@pdata+2,bytes)
              bytes:=0           
            ser.tx(ACK)                                 'get more
    ser.tx(ACK)
  \sdfat.closeFile 


 
PUB receive|key,i,size,seconds,timer,packet,d,crc,p,j,k,deot
  'Ymodem protocol: http://timeline.textfiles.com/1988/10/14/1/FILES/ymodem.txt
  '                 http://en.wikipedia.org/wiki/XMODEM
  
  ser.str(string(27,"[2JReceive a file from SD card."))
  ifnot GetName                       'get filename
    return

  'Transmit file to host
  sdfat.openFile(@fbuf,"r")    
  size:=sdfat.listSize
  ser.str(string(13,10,"Transmitting file.  Instruct terminal to receive YMODEM file now."))
  
  timer:=cnt
  key:=0
  'Wait for NAK from host:  Signal to start sending
  repeat until key==Cee
    i:=ser.rxcheck
    if i>0
      key:=i
    i:=cnt
    if ((cnt-timer)/clkfreq)>10           '10 second timeout
      ser.str(string(13,10,"Failure.  No response from host.."))
      return 'fail  
 
  'start sending packets
  packet:=0
  repeat
    timer:=cnt
    crc:=0
    deot:=false  
    'send header
    ser.tx(SOH)
    ser.tx(packet)
    ser.tx(!packet)

    'construct packet
    if packet==0
      'Send filename and length
      i:=strsize(@fbuf)
      bytemove(@pdata,@fbuf,i+1)
      p:=num.tostr(size,num#DEC)
      j:=strsize(p)
      bytemove(@pdata+i+1,p,j+1)
      repeat k from i+1+j+1 to 128
        pdata[k]:=0
    else  
      'data packet
      repeat i from 0 to 127
        d:=sdfat.readByte
        if d==-1
          'end of file
          repeat i from i to 127
            d:=EOT'Zee
            pdata[i]:=d
            deot:=true
          quit          
        else
          if d<0 
            d:=EOT
            ser.tx(d)
            return 'fail      

        pdata[i]:=d

    'send packet
    repeat i from 0 to 127
      ser.tx(pdata[i])
      crc:=UpdateCRC(pdata[i],crc)       
                      
    ser.tx((crc>>8)&$FF)
    ser.tx(crc&$FF)

    repeat
      i:=ser.rxcheck
      if i==ACK
        quit
      if i==NAK
        'retransmit packet
        repeat i from 0 to 127
          ser.tx(pdata[i])
          ser.tx((crc>>8)&$FF)
          ser.tx(crc&$FF)
      if ((cnt-timer)/clkfreq)>10
        ser.tx(EOT)
        ser.str(string(13,10,"Timeout failure."))
        return 'fail
    if (deot==true)'Zee) 'done
      quit
    else
      packet++
      timer:=cnt    

  'send EOT wait for ACK and send end of batch packet
  ser.tx(EOT)
  repeat
    i:=ser.rxcheck
    if i==ACK
      'now, wait for "C"
      timer:=cnt
      key:=0
      repeat until key==Cee
        i:=ser.rxcheck
        if i>0
          key:=i
        i:=cnt
        if ((cnt-timer)/clkfreq)>10           '10 second timeout
          ser.str(string(13,10,"Failure.  No response from host.."))
          return 'fail
      'now, transmit null packet and wait for ACK
      key:=0
      repeat until key==ACK
        ser.tx(SOH)
        ser.tx(0)
        ser.tx($FF)
        crc:=0
        repeat 128
          ser.tx(0)
          crc:=UpdateCRC(0,crc)
        ser.tx((crc>>8)&$FF)
        ser.tx(crc&$FF)
        'wait for ack
        key:=ser.rx
        if key<>ACK and key<>NAK
          return 'fail  
      quit  'all done!
    if i>0
      ser.tx(EOT)

  ser.str(string(13,10,"YModem receive from SD complete.",13,10))
  sdfat.closeFile 
    
PRI UpdateCRC(data,crc):newcrc|i
 'look here:http://web.mit.edu/6.115/www/miscfiles/amulet/amulet-help/xmodem.htm

  crc:=crc^(data<<8)
  repeat i from 0 to 7
    if crc&$8000
      crc:=((crc<<1)&$FFFF)^$1021
    else
      crc:=(crc<<=1)&$FFFF

  return crc&$FFFF     

PRI GetName | key, i
  result := false
  ser.str(string(13,10,"Enter filename in 8.3 format (press ESC to abort):"))
  key:=0
  i:=0
  
  repeat until key==13
    key:=ser.rx
    if (key==27)
      AbortMsg
      return 'abort
    ser.tx(key)
    if key == 8
      i -= 1
    elseif key<>13 
      fbuf[i++]:=key    
    else
      fbuf[i]:=0  'append end of string mark
      result := true
      
  if strsize(@fbuf)>12
      ser.str(string(13,10,"Filename too long!  Use 8.3 format."))
      return 'fail       

PRI Waitkey(k,stringout)|key  'show string and wait for key=k
  ser.str(stringout)
  key:=0
  repeat until key==k
    repeat 
      key:=ser.rxcheck
    while key>0 and key<>k

PRI GetKey | key ' returns keypress
    key := 0
    repeat 
      key:=ser.rxcheck
    while key == -1
    return key
    
PRI Debug(msg)


  if strsize(msg) > 2
    \sdfat.closeFile
    waitcnt(cnt+clkfreq) ' need 3 seconds or message disapears? works with 1 /2 combo
    ser.tx(EOT) 
    waitcnt(cnt+clkfreq*2) ' at least 2 or message disapears 
'    ser.str(string("DEBUG"))
    ser.str(string(13,10))
    ser.str(msg)
    
    Waitkey(32,string(13,10,"Press spacebar to continue",13,10,7))  

 